%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Written by Justin Legleiter %
% For Use in:                 %
% 09-723 Proximal Probe Tech  %
% (c)2004                     %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% This code makes use of:
% Painless MATLAB GUIs for everybody
% (c) 2003, University of Cambridge
% Stefan Bleeck (stefan@bleeck.de)
% http://www.mrc-cbu.cam.ac.uk/cnbh/aimmanual/tools/parameter
% $Date: 2004/07/26$

%Welcome and thanks for peaking!!!!
function Homework7GUI(params)
%defining a butt load of parameters
global Kspring; global Bdamp; global Mtip;global Ncycles; global PtsPerCycle;
global Zstart; global Zprime; global Finitial; global Fres; global Phi
global Skippy; global Fres; global SimStep; global Nsteps; global SimTime;
global Npts; global PointMat;global Foper; global Fo; global NginPT; 
global Ztraj; global dummy;global Bpower;global Penergy; global Tenergy;
global Kenergy; global Dpower;global time; global Denergy;global Benergy;
global Atip; global Rtip; global sigma; global Zend; global RampRate;
global Q; global IndentConst; global aDMT;global RampPos; global FLJ
global Wtotal; global r;global begin;global SweepStart;global SweepWidth;
global ResPeak,global Wopers;global Ao;global Fext;global Amplitude;
global FoInt;global Xlevel; global bool_value;
%parameters pooped out

%global ModParams
% check the number of inputs
if nargin==0 % initial call without parameters.
params=parameter('Dynamic AFM','nonmodal', 'northwest'); % create an object of the parameter class with name
    % now we add some items to it:
params=add(params,'panel','Cantilever Parameters',4);
params=add(params,'float','Kspring',unit_none,0.5);%textbox for entering Kspring
params=add(params,'float','Fres',unit_none,30000);%textbox for entering Fres
params=add(params,'float','Q',unit_none,50);%textbox for entering Fres
params=add(params,'float','amplitude',unit_none,0);%textbox for entering Fres

%params=add(params,'float','Bdamp',unit_none,5.3052e-008)%textbox for entering Bdamp
%params=add(params,'float','Mtip',unit_none,1)%textbox for entering Mtip
params=add(params,'panel','Sim Parameters',5);
params=add(params,'float','Ncycles',unit_none,10);%textbox for entering Ncycles
params=add(params,'float','PtsPerCycle',unit_none,256);%textbox for entering PtsPerCycle
params=add(params,'float','Zstart',unit_none,30);%textbox for entering Zstart
params=add(params,'float','Zend',unit_none,0);%textbox for entering Zend
params=add(params,'float','Zprime',unit_none,0);%textbox for entering Zprime
%params=add(params,'float','Fo',unit_none,0)%textbox for entering Fo
%params=add(params,'float','Foper (Hz)',unit_none,30000);%textbox for entering Foper
params=add(params,'panel','Fext Parameters',5);
params=add(params,'float','sigma',unit_none,0.35);%textbox for entering sigma in nm
params=add(params,'float','Atip',unit_none,0.425);%textbox for entering Atip in 10^-19J
params=add(params,'float','Rtip',unit_none,10);%textbox for entering Rtip in nm
%params=add(params,'float','IndentConst',unit_none,12948000)%textbox for entering Rtip in nm
string_struct={'silicon        ','silicon dioxide','silicon nitride','gold           ','nickel         ','tungsten       ','platinum       ','irydium        ','HOPG           ','glassy polymer ','soft polymer   '};
params=add(params,'pop-up menu','IndentConst',string_struct);%textbox for entering Rtip in nm
params=add(params,'float','aDMT',unit_none,4e-10);%textbox for entering Rtip in nm

%params=add(params,'float','Phi (rad)',unit_none,0)%textbox for entering Phi
params=add(params,'button','Set','Homework7GUI(params)');%Button to run sim 
params=add(params,'button','RunSim','ModelRun3');%Button to run sim 

%params=add(params,'button','Take Points','TakeTrajPoints2')%Button to take points
params=add(params,'button','FFT analysis','AnalyzeFFT');%Button to do fft analysis
%params=add(params,'button','Individual TP','IndyTP')%Button to plot individual surface potentials
params=add(params,'button','Tuning','TuningGui');%Button to plot individual surface potentials
params=add(params,'bool','Turn on #4',0);%bool for problem 4
%params=add(params,'button','help static','msgbox(''Change param, Set, RunSim'')',1)%Button for no particular reason
%params=add(params,'button','help dynamic','msgbox(''Change param, Set, Tune, RunSim'')',1)%Button for no particular reason


    parametergui(params); % create the gui
    return  % and return to the shell. From now on the gui has the control 
end

% if we are here then we are called from the gui with the parameter
% structure in "params"

%creating paramter 
Fres=get(params,'Fres');%default setting for resonance frequency in Hz
Kspring=get(params,'Kspring');
%Bdamp=get(params,'Bdamp');
Q=get(params,'Q');%Q factor default setting
Ao=get(params,'amplitude');
Ao=Ao*10^-9;
if Ao==0
Fo=Ao/Q;
else 
FoInt=Ao/Q;
end
Mtip=Kspring/(2*pi*Fres)^2%calculating Mtip
Bdamp=(Mtip * 2*pi*Fres) / Q;%calculating Bdamp based on Q and Fres
%Mtip=get(params,'Mtip');
Ncycles=get(params,'Ncycles');
PtsPerCycle=get(params,'PtsPerCycle');
Zstart=get(params,'Zstart');
Zend=get(params,'Zend');
Zstart=Zstart*10^-9;
Zend=Zend*10^-9;
Zprime=get(params,'Zprime');
%Fo=get(params,'Fo');
%Foper=get(params,'Foper (Hz)');
%Foper=Fres;
%Q = (Mtip * 2*pi*Fres) / Bdamp;
Ncycles=Ncycles*Q;% based on Q cycles for good reasons you will discover later
%Phi=get(params,'Phi (rad)');
Phi=0;
skippy= 1;% this is an artifact
Atip=get(params,'Atip');
Rtip=get(params,'Rtip');
sigma=get(params,'sigma');
%IndentConst=143870;% already available for DMT potential in the future (planning ahead)
%aDMT=4e-10;% already available for DMT potential in the future (planning ahead)
IndentConstString=get(params,'IndentConst');% already available for DMT potential in the future (planning ahead)
aDMT=get(params,'aDMT');% already available for DMT potential in the future (planning ahead)
Atip=Atip*10^-18;
Rtip=Rtip*10^-9;
sigma=sigma*10^-9;
%Fo=Fo*10^-9;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%determine
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%IndentConst%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if IndentConstString=='silicon        '
    IndentConst=12948000;
end

if IndentConstString=='silicon dioxide' 
    IndentConst=6501300;
end
if IndentConstString=='silicon nitride' 
    IndentConst=11807000;
end
if IndentConstString=='gold           '
    IndentConst=7999100;
end
if IndentConstString=='nickel         '
    IndentConst=13888000;    
end
if IndentConstString=='tungsten       '
    IndentConst=17050000;    
end
if IndentConstString=='platinum       '
    IndentConst=12615000;    
end
if IndentConstString=='irydium        '
    IndentConst=5829600;    
end
if IndentConstString=='HOPG           '
    IndentConst=    13666000;
end
if IndentConstString=='glassy polymer '
    IndentConst=   143870;
end
if IndentConstString=='soft polymer   '
    IndentConst=  14460;  
end



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%End


%calculating parameters
%dummy=((Kspring/Mtip)^0.5)/(2*pi);
dummy=Fres;%dummy wasn't hard to figure out. We weren't very sneaky.

% if Fo==0%deciding if we are driving or not, important for scaling.
%         SimStep = (1 / dummy) / PtsPerCycle;
%     else
%         SimStep = (1 / Foper) / PtsPerCycle;
% end
% 
% Nsteps=(Ncycles-1)*PtsPerCycle;%scaling parameters for simulation
% SimTime=Nsteps*SimStep;
% Npts = Nsteps + 1;
% RampRate=(Zstart-Zend)/(SimTime/2);

% %%%%%%%%%%%%%%%Calculate Potentials and other crap%%%%%%%%%%%yippy%%%%%%
% r=0.150e-9:0.1e-10:5e-9;%distance to move
% c=((Atip*Rtip)/(6*sigma));
% c1=(sigma./r);
% c2=c1.^7;
% w=c*(((1/210).*c2)-c1);%potential Lennard Jones
% wmin=min(w);
% 
% FLJ2=Atip*Rtip*((sigma^6-30*r.^6)./(180*r.^8));% Force Lennard Jones
% FLJmin=min(FLJ2);
% 
% FLJD=diff(FLJ2);%Force Derivative Lennard Jones
% FLJDmax=max(FLJD);
% 
% %construct surface potential do-hicky
% for i=1:length(r)%creating a list of tip-sample separations
%     begin(i)=-r(end-i+1);
% end
% for i=1:length(r)%creating a list of deflections relative to tip-sample separations
% x(i,:)=begin(i):0.1e-10:begin(i)+r(end-1);
% end
% Wtip=0.5*Kspring.*x.^2;%calculating potential of tip deflections relative to separation
% for i = 1:length(r)%calculating total potential
%    
%     Wtotal(:,i)=w(:)+Wtip(:,i);
%    
% end
% 
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%D'OH%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% %run simulation
% sim('ForceCurveModelDMT')%calling model
% clear Traj;
% %plotting results%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Traj(1,:)=time';
% Traj(2,:)=Ztraj';
% Tenergy=Penergy+Kenergy;
% [minramp,minrampI]=min(RampPos);
% %plotting data%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% % figure (1)
% % set(gcf,'Color', [1 1 1]);
% % set (gcf, 'NumberTitle','off');
% % set (gcf, 'name','Potential - Fhqwhgads');
% % 
% % plot(r,w)
% % axis([ 0 r(end)  wmin 0])
% % xlabel 'distance'
% % ylabel 'LJ Potential'
% 
% figure(2)
% set(gcf,'Color', [1 1 1]);
% set (gcf, 'NumberTitle','off');
% set (gcf, 'name','Deflection FC');
% 
% plot(RampPos(1:minrampI),Ztraj(1:minrampI),'b',RampPos(minrampI:end),Ztraj(minrampI:end),'r')
% xlabel 'Distance (m)'
% ylabel 'Deflection (m)'
% legend('approach', 'retract')
% 
% 
% % figure(3)
% % set(gcf,'Color', [1 1 1]);
% % set (gcf, 'NumberTitle','off');
% % set (gcf, 'name','Force LJ');
% % 
% % plot(r,FLJ2)
% % axis([ 0 r(end)  FLJmin 0])
% % xlabel 'distance'
% % ylabel 'LJ Force'
% 
% 
% figure(4)
% set(gcf,'Color', [1 1 1]);
% set (gcf, 'NumberTitle','off');
% set (gcf, 'name','Force FC');
% 
% plot(RampPos(1:minrampI),FLJ(1:minrampI),'b',RampPos(minrampI:end),FLJ(minrampI:end),'r')
% xlabel 'Distance (nm)'
% ylabel 'Force'
% set(gcf,'Color', [1 1 1]);
% legend('approach', 'retract')
% 
% % figure (5)
% % set(gcf,'Color', [1 1 1]);
% % set (gcf, 'NumberTitle','off');
% % set (gcf, 'name','Force derivative LJ');
% % 
% % plot(r(1:end-1),FLJD)
% % axis([ 0 r(end-1)  0 FLJDmax])
% % xlabel 'distance'
% % ylabel 'LJ Dforce'
% 
% % figure(6)
% % set(gcf,'Color', [1 1 1]);
% % set (gcf, 'NumberTitle','off');
% % set (gcf, 'name','Total Potential');
% % surf(0-begin,r,Wtotal)
% % view(110,60);
% % set(gca,'XDir','reverse')
% % grid off
% % set(gcf,'color','white')
% % colormap hot
% % shading interp;
% % xlabel 'tip-surf dist'
% % ylabel 'distance'
% % zlabel 'potential'
% 
%%%%%%%%%%%%%%%%%%%%Calculating Xlevel
bool_value=get(params,'Turn on #4');
