%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Written by Justin Legleiter %
% For Use in:                 %
% 09-723 Proximal Probe Tech  %
% (c)2004                     %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


global Kspring; global Bdamp; global Mtip;global Ncycles; global PtsPerCycle;
global Zstart; global Zprime; global Finitial; global Fres; global Phi
global Skippy; global Fres; global SimStep; global Nsteps; global SimTime;
global Npts; global PointMat;global Foper; global Fo; global NginPT; 
global Ztraj; global dummy;global Bpower;global Penergy; global Tenergy;
global Kenergy; global Dpower;global time; global Denergy;global Benergy;
global Atip; global Rtip; global sigma; global Zend; global RampRate;
global Q; global IndentConst; global aDMT;global RampPos; global FLJ
global Wtotal; global r;global begin;global SweepStart;global SweepWidth;
global ResPeak,global Wopers;global Ao;global Fext;global Amplitude;
global Xlevel;global bool_value;


if Fo==0 %deciding if we are driving or not, important for scaling.
         SimStep = (1 / Fres) / PtsPerCycle;
    Foper=Fres;
    
        
else
   SimStep = (1 / Foper) / PtsPerCycle;
        Zstart=Zstart+(0.5*Ao);
        Zend=Zend+(0.5*Ao);
end

Nsteps=(Ncycles-1)*PtsPerCycle;%scaling parameters for simulation
SimTime=Nsteps*SimStep;
Npts = Nsteps + 1;
RampRate=(Zstart-Zend)/(SimTime/2);
%run simulation
SimPts=round((SimTime/SimStep)+1);
Xlevel=zeros(SimPts,2);
if bool_value==0
    
    Xlevel(1:SimPts,1:2)=0;
    Xlevel(1:SimPts,1)=0:1:SimPts-1;
    Xlevel(1:SimPts,1)=Xlevel(1:SimPts,1)*SimStep;
    %Xlevel=Xlevel';
else
   
   Xlevel(1:SimPts,1:2)=0;
    Xlevel(1:SimPts,1)=0:1:SimPts-1;
    Xlevel(1:SimPts,1)=Xlevel(1:SimPts,1)*SimStep;
    StepStart=round(0.5*SimPts);
    StepEnd=round(0.75*SimPts);
    Xlevel(StepStart:StepEnd,2)=5e-9;
       % Xlevel=Xlevel';

end
if bool_value==1
    sim('auxiliary')
else
sim('ForceCurveModelDMT_2')%calling model
end
clear Traj;
%plotting results%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Traj(1,:)=time';
Traj(2,:)=Ztraj';
Tenergy=Penergy+Kenergy;
[minramp,minrampI]=min(RampPos);
%plotting data%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if Fo==0
    
% figure (1)
% set(gcf,'Color', [1 1 1]);
% set (gcf, 'NumberTitle','off');
% set (gcf, 'name','Potential - Fhqwhgads');
% 
% plot(r,w)
% axis([ 0 r(end)  wmin 0])
% xlabel 'distance'
% ylabel 'LJ Potential'
if RampRate>0
figure(2)
set(gcf,'Color', [1 1 1]);
set (gcf, 'NumberTitle','off');
set (gcf, 'name','Deflection and Amplitude');
subplot(2,1,1)
plot(RampPos(1:minrampI),Ztraj(1:minrampI),'b',RampPos(minrampI:end),Ztraj(minrampI:end),'r')
xlabel 'Distance (m)'
ylabel 'Deflection (m)'
legend('approach', 'retract')
subplot(2,1,2)
plot(RampPos(1:minrampI),Amplitude(1:minrampI),'b',RampPos(minrampI:end),Amplitude(minrampI:end),'r')
xlabel 'Distance (m)'
ylabel 'Amplitude (m)'

% figure(3)
% set(gcf,'Color', [1 1 1]);
% set (gcf, 'NumberTitle','off');
% set (gcf, 'name','Force LJ');
% 
% plot(r,FLJ2)
% axis([ 0 r(end)  FLJmin 0])
% xlabel 'distance'
% ylabel 'LJ Force'


figure(4)
set(gcf,'Color', [1 1 1]);
set (gcf, 'NumberTitle','off');
set (gcf, 'name','Force');

plot(RampPos(1:minrampI),Fext(1:minrampI),'b',RampPos(minrampI:end),Fext(minrampI:end),'r')
xlabel 'Distance (nm)'
ylabel 'Force'
set(gcf,'Color', [1 1 1]);
legend('approach', 'retract')


else
            CycleNum=time*Foper;
   figure(2)
set(gcf,'Color', [1 1 1]);
set (gcf, 'NumberTitle','off');
set (gcf, 'name','Deflection and Amplitude');
subplot(2,1,1)
plot(CycleNum,Ztraj)
xlabel 'Cycle Number'
ylabel 'Deflection (m)'
%legend('approach', 'retract') 
subplot(2,1,2)
plot(CycleNum,Amplitude)
xlabel 'Cycle Number'
ylabel 'Amplitude (m)'

    figure(4)
set(gcf,'Color', [1 1 1]);
set (gcf, 'NumberTitle','off');
set (gcf, 'name','Force');

plot(CycleNum,Fext)
xlabel 'Cycle Number'
ylabel 'Force'
set(gcf,'Color', [1 1 1]);
end
% figure (5)
% set(gcf,'Color', [1 1 1]);
% set (gcf, 'NumberTitle','off');
% set (gcf, 'name','Force derivative LJ');
% 
% plot(r(1:end-1),FLJD)
% axis([ 0 r(end-1)  0 FLJDmax])
% xlabel 'distance'
% ylabel 'LJ Dforce'

% figure(6)
% set(gcf,'Color', [1 1 1]);
% set (gcf, 'NumberTitle','off');
% set (gcf, 'name','Total Potential');
% surf(0-begin,r,Wtotal)
% view(110,60);
% set(gca,'XDir','reverse')
% grid off
% set(gcf,'color','white')
% colormap hot
% shading interp;
% xlabel 'tip-surf dist'
% ylabel 'distance'
% zlabel 'potential'
else
    if RampRate>0
    CycleNum=time*Foper;
   figure(2)
set(gcf,'Color', [1 1 1]);
set (gcf, 'NumberTitle','off');
set (gcf, 'name','Deflection and Amplitude');
subplot(2,1,1)
plot(CycleNum(1:minrampI),Ztraj(1:minrampI),'b',CycleNum(minrampI:end),Ztraj(minrampI:end),'r')
xlabel 'Cycle Number'
ylabel 'Deflection (m)'
legend('approach', 'retract') 
subplot(2,1,2)
plot(CycleNum(1:minrampI),Amplitude(1:minrampI),'b',CycleNum(minrampI:end),Amplitude(minrampI:end),'r')
xlabel 'Cycle Number'
ylabel 'Amplitude (m)'

    figure(4)
set(gcf,'Color', [1 1 1]);
set (gcf, 'NumberTitle','off');
set (gcf, 'name','Force');

plot(CycleNum(1:minrampI),Fext(1:minrampI),'b',CycleNum(minrampI:end),Fext(minrampI:end),'r')
xlabel 'Cycle Number'
ylabel 'Force'
set(gcf,'Color', [1 1 1]);
legend('approach', 'retract')
    else
        CycleNum=time*Foper;
   figure(2)
set(gcf,'Color', [1 1 1]);
set (gcf, 'NumberTitle','off');
set (gcf, 'name','Deflection and Amplitude');
subplot(2,1,1)
plot(CycleNum,Ztraj)
xlabel 'Cycle Number'
ylabel 'Deflection (m)'
%legend('approach', 'retract') 
subplot(2,1,2)
plot(CycleNum,Amplitude)
xlabel 'Cycle Number'
ylabel 'Amplitude (m)'

    figure(4)
set(gcf,'Color', [1 1 1]);
set (gcf, 'NumberTitle','off');
set (gcf, 'name','Force');

plot(CycleNum,Fext)
xlabel 'Cycle Number'
ylabel 'Force'
set(gcf,'Color', [1 1 1]);
%legend('approach', 'retract')
        
    end
end
